searchNodes=[{"doc":"","ref":"Mix.Tasks.Waffle.html","title":"Mix.Tasks.Waffle","type":"task"},{"doc":"A task for generating waffle uploader modules.If generating an uploader in a Phoenix project, your a uploader will be generated in lib/[APP_NAME]_web/uploaders/Examplemix waffle.g avatar # creates lib/[APP_NAME]_web/uploaders/avatar.exIf not generating an uploader in a Phoenix project, then you must pass the path to where the uploader should be generated.Examplemix waffle.g avatar uploaders/avatar.ex # creates uploaders/avatar.ex","ref":"Mix.Tasks.Waffle.G.html","title":"Mix.Tasks.Waffle.G","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Waffle.G.html#run/1","title":"Mix.Tasks.Waffle.G.run/1","type":"function"},{"doc":"Waffle is a flexible file upload library for Elixir with straightforward integrations for Amazon S3 and ImageMagick.InstallationAdd the latest stable release to your mix.exs file, along with the required dependencies for ExAws if appropriate:defp deps do [ {:waffle, &quot;~&gt; 1.1.0&quot;}, # If using S3: {:ex_aws, &quot;~&gt; 2.1.2&quot;}, {:ex_aws_s3, &quot;~&gt; 2.0&quot;}, {:hackney, &quot;~&gt; 1.9&quot;}, {:sweet_xml, &quot;~&gt; 0.6&quot;} ] endThen run mix deps.get in your shell to fetch the dependencies.ConfigurationWaffle expects certain properties to be configured at the application level:config :waffle, storage: Waffle.Storage.S3, # or Waffle.Storage.Local bucket: {:system, &quot;AWS_S3_BUCKET&quot;}, # if using S3 asset_host: &quot;http://static.example.com&quot; # or {:system, &quot;ASSET_HOST&quot;} # If using S3: config :ex_aws, json_codec: JasonAlong with any configuration necessary for ExAws.Storage ProvidersWaffle ships with integrations for Waffle.Storage.Local and Waffle.Storage.S3. Alternative storage providers may be supported by the community:Rackspace - arc_rackspaceManta - arc_mantaOVH - arc_ovhGoogle Cloud Storage - waffle_gcsMicrosoft Azure Storage - arc_azureUsage with EctoWaffle comes with a companion package for use with Ecto. If you intend to use Waffle with Ecto, it is highly recommended you also add the waffle_ecto dependency. Benefits include:Changeset integrationVersioned urls for cache busting (.../thumb.png?v=63601457477)Getting Started: Defining your UploadWaffle requires a definition module which contains the relevant configuration to store and retrieve your files.This definition module contains relevant functions to determine:Optional transformations of the uploaded fileWhere to put your files (the storage directory)What to name your filesHow to secure your files (private? Or publicly accessible?)Default placeholdersTo start off, generate an attachment definition:mix waffle.g avatarThis should give you a basic file in:web/uploaders/avatar.exCheck this file for descriptions of configurable options.Further readingWaffle.Definitionfull example","ref":"Waffle.html","title":"Waffle","type":"module"},{"doc":"Delete files from a defined adapter.After an object is stored through Waffle, you may optionally remove it. To remove a stored object, pass the same path identifier and scope from which you stored the object.# Without a scope: {:ok, original_filename} = Avatar.store(&quot;/Images/me.png&quot;) :ok = Avatar.delete(original_filename) # With a scope: user = Repo.get!(User, 1) {:ok, original_filename} = Avatar.store({&quot;/Images/me.png&quot;, user}) # example 1 :ok = Avatar.delete({original_filename, user}) # example 2 user = Repo.get!(User, 1) :ok = Avatar.delete({user.avatar, user})","ref":"Waffle.Actions.Delete.html","title":"Waffle.Actions.Delete","type":"module"},{"doc":"","ref":"Waffle.Actions.Delete.html#delete/2","title":"Waffle.Actions.Delete.delete/2","type":"function"},{"doc":"Store files to a defined adapter.The upload definition file responds to Avatar.store/1 which accepts either:A path to a local fileA path to a remote http or https fileA map with a filename and path keys (eg, a %Plug.Upload{})A map with a filename and binary keys (eg, %{filename: &quot;image.png&quot;, binary: &lt;&lt;255,255,255,...&gt;&gt;})A two-tuple consisting of one of the above file formats as well as a scope object.Example usage as general file store:# Store any locally accessible file Avatar.store(&quot;/path/to/my/file.png&quot;) #=&gt; {:ok, &quot;file.png&quot;} # Store any remotely accessible file Avatar.store(&quot;http://example.com/file.png&quot;) #=&gt; {:ok, &quot;file.png&quot;} # Store a file directly from a `%Plug.Upload{}` Avatar.store(%Plug.Upload{filename: &quot;file.png&quot;, path: &quot;/a/b/c&quot;}) #=&gt; {:ok, &quot;file.png&quot;} # Store a file from a connection body {:ok, data, _conn} = Plug.Conn.read_body(conn) Avatar.store(%{filename: &quot;file.png&quot;, binary: data})Example usage as a file attached to a scope:scope = Repo.get(User, 1) Avatar.store({%Plug.Upload{}, scope}) #=&gt; {:ok, &quot;file.png&quot;}This scope will be available throughout the definition module to be used as an input to the storage parameters (eg, store files in /uploads/\#{scope.id}).","ref":"Waffle.Actions.Store.html","title":"Waffle.Actions.Store","type":"module"},{"doc":"","ref":"Waffle.Actions.Store.html#store/2","title":"Waffle.Actions.Store.store/2","type":"function"},{"doc":"Url generation.Saving your files is only the first half of any decent storage solution. Straightforward access to your uploaded files is equally as important as storing them in the first place.Often times you will want to regain access to the stored files. As such, Waffle facilitates the generation of urls.# Given some user record user = %{id: 1} Avatar.store({%Plug.Upload{}, user}) #=&gt; {:ok, &quot;selfie.png&quot;} # To generate a regular, unsigned url (defaults to the first version): Avatar.url({&quot;selfie.png&quot;, user}) #=&gt; &quot;https://bucket.s3.amazonaws.com/uploads/1/original.png&quot; # To specify the version of the upload: Avatar.url({&quot;selfie.png&quot;, user}, :thumb) #=&gt; &quot;https://bucket.s3.amazonaws.com/uploads/1/thumb.png&quot; # To generate a signed url: Avatar.url({&quot;selfie.png&quot;, user}, :thumb, signed: true) #=&gt; &quot;https://bucket.s3.amazonaws.com/uploads/1/thumb.png?AWSAccessKeyId=AKAAIPDF14AAX7XQ&amp;Signature=5PzIbSgD1V2vPLj%2B4WLRSFQ5M%3D&amp;Expires=1434395458&quot; # To generate urls for all versions: Avatar.urls({&quot;selfie.png&quot;, user}) #=&gt; %{original: &quot;https://.../original.png&quot;, thumb: &quot;https://.../thumb.png&quot;}Default urlIn cases where a placeholder image is desired when an uploaded file is not present, Waffle allows the definition of a default image to be returned gracefully when requested with a nil file.def default_url(version) do MyApp.Endpoint.url &lt;&gt; &quot;/images/placeholders/profile_image.png&quot; end Avatar.url(nil) #=&gt; &quot;http://example.com/images/placeholders/profile_image.png&quot; Avatar.url({nil, scope}) #=&gt; &quot;http://example.com/images/placeholders/profile_image.png&quot;Virtual HostTo support AWS regions other than US Standard, it may be required to generate urls in the virtual_host style. This will generate urls in the style: https://\#{bucket}.s3.amazonaws.com instead of https://s3.amazonaws.com/\#{bucket}.To use this style of url generation, your bucket name must be DNS compliant.This can be enabled with:config :waffle, virtual_host: trueWhen using virtual hosted–style buckets with SSL, the SSL wild card certificate only matches buckets that do not contain periods. To work around this, use HTTP or write your own certificate verification logic.Asset HostYou may optionally specify an asset host rather than using the default bucket.s3.amazonaws.com format.In your application configuration, you'll need to provide an asset_host value:config :waffle, asset_host: &quot;https://d3gav2egqolk5.cloudfront.net&quot;, # For a value known during compilation asset_host: {:system, &quot;ASSET_HOST&quot;} # For a value not known until runtime","ref":"Waffle.Actions.Url.html","title":"Waffle.Actions.Url","type":"module"},{"doc":"","ref":"Waffle.Actions.Url.html#url/4","title":"Waffle.Actions.Url.url/4","type":"function"},{"doc":"Defines uploader to manage files.defmodule Avatar do use Waffle.Definition endConsists of several components to manage different parts of file managing process.Waffle.Definition.VersioningWaffle.Definition.StorageWaffle.Actions.StoreWaffle.Actions.DeleteWaffle.Actions.Url","ref":"Waffle.Definition.html","title":"Waffle.Definition","type":"module"},{"doc":"Uploader configuration.Add use Waffle.Definition inside your module to use it as uploader.Storage directoryconfig :waffle, storage_dir: &quot;my/dir&quot;The storage directory to place files. Defaults to uploads, but can be overwritten via configuration options :storage_dirThe storage dir can also be overwritten on an individual basis, in each separate definition. A common pattern for user profile pictures is to store each user's uploaded images in a separate subdirectory based on their primary key:def storage_dir(version, {file, scope}) do &quot;uploads/users/avatars/\#{scope.id}&quot; endNote: If you are &quot;attaching&quot; a file to a record on creation (eg, while inserting the record at the same time), then you cannot use the model's id as a path component. You must either (1) use a different storage path format, such as UUIDs, or (2) attach and update the model after an id has been given. Read more about how to integrate it with EctoNote: The storage directory is used for both local filestorage (as the relative or absolute directory), and S3 storage, as the path name (not including the bucket).Asynchronous File UploadingIf you specify multiple versions in your definition module, each version is processed and stored concurrently as independent Tasks. To prevent an overconsumption of system resources, each Task is given a specified timeout to wait, after which the process will fail. By default this is 15 seconds.If you wish to change the time allocated to version transformation and storage, you may add a configuration parameter:config :waffle, :version_timeout, 15_000 # millisecondsTo disable asynchronous processing, add @async false to your upload definition.Storage of filesWaffle currently supportsWaffle.Storage.S3Waffle.Storage.LocalOverride the __storage function in your definition module if you want to use a different type of storage for a particular uploader.File ValidationWhile storing files on S3 (rather than your harddrive) eliminates some malicious attack vectors, it is strongly encouraged to validate the extensions of uploaded files as well.Waffle delegates validation to a validate/1 function with a tuple of the file and scope. As an example, to validate that an uploaded file conforms to popular image formats, you may use:defmodule Avatar do use Waffle.Definition @extension_whitelist ~w(.jpg .jpeg .gif .png) def validate({file, _}) do file_extension = file.file_name |&gt; Path.extname() |&gt; String.downcase() Enum.member?(@extension_whitelist, file_extension) end endAny uploaded file failing validation will return {:error, :invalid_file} when passed through to Avatar.store.","ref":"Waffle.Definition.Storage.html","title":"Waffle.Definition.Storage","type":"module"},{"doc":"Define proper name for a version.It may be undesirable to retain original filenames (eg, it may contain personally identifiable information, vulgarity, vulnerabilities with Unicode characters, etc).You may specify the destination filename for uploaded versions through your definition module.A common pattern is to combine directories scoped to a particular model's primary key, along with static filenames. (eg: user_avatars/1/thumb.png).# To retain the original filename, but prefix the version and user id: def filename(version, {file, scope}) do file_name = Path.basename(file.file_name, Path.extname(file.file_name)) &quot;\#{scope.id}_\#{version}_\#{file_name}&quot; end # To make the destination file the same as the version: def filename(version, _), do: version","ref":"Waffle.Definition.Versioning.html","title":"Waffle.Definition.Versioning","type":"module"},{"doc":"","ref":"Waffle.Definition.Versioning.html#resolve_file_name/3","title":"Waffle.Definition.Versioning.resolve_file_name/3","type":"function"},{"doc":"Apply transformation to files.Waffle can be used to facilitate transformations of uploaded files via any system executable. Some common operations you may want to take on uploaded files include resizing an uploaded avatar with ImageMagick or extracting a still image from a video with FFmpeg.To transform an image, the definition module must define a transform/2 function which accepts a version atom and a tuple consisting of the uploaded file and corresponding scope.This transform handler accepts the version atom, as well as the file/scope argument, and is responsible for returning one of the following::noaction - The original file will be stored as-is.:skip - Nothing will be stored for the provided version.{executable, args} - The executable will be called with System.cmd with the format \#{original_file_path} \#{args} \#{transformed_file_path}.{executable, fn(input, output) -&gt; args end} If your executable expects arguments in a format other than the above, you may supply a function to the conversion tuple which will be invoked to generate the arguments. The arguments can be returned as a string (e.g. – &quot; \#{input} -strip -thumbnail 10x10 \#{output}&quot;) or a list (e.g. – [input, &quot;-strip&quot;, &quot;-thumbnail&quot;, &quot;10x10&quot;, output]) for even more control.{executable, args, output_extension} - If your transformation changes the file extension (eg, converting to png), then the new file extension must be explicit.ImageMagick transformationsAs images are one of the most commonly uploaded filetypes, Waffle has a recommended integration with ImageMagick's convert tool for manipulation of images. Each upload definition may specify as many versions as desired, along with the corresponding transformation for each version.The expected return value of a transform function call must either be :noaction, in which case the original file will be stored as-is, :skip, in which case nothing will be stored, or {:convert, transformation} in which the original file will be processed via ImageMagick's convert tool with the corresponding transformation parameters.The following example stores the original file, as well as a squared 100x100 thumbnail version which is stripped of comments (eg, GPS coordinates):defmodule Avatar do use Waffle.Definition @versions [:original, :thumb] def transform(:thumb, _) do {:convert, &quot;-strip -thumbnail 100x100^ -gravity center -extent 100x100&quot;} end endOther examples:# Change the file extension through ImageMagick&#39;s `format` parameter: {:convert, &quot;-strip -thumbnail 100x100^ -gravity center -extent 100x100 -format png&quot;, :png} # Take the first frame of a gif and process it into a square jpg: {:convert, fn(input, output) -&gt; &quot;\#{input}[0] -strip -thumbnail 100x100^ -gravity center -extent 100x100 -format jpg \#{output}&quot;, :jpg}For more information on defining your transformation, please consult ImageMagick's convert documentation.Note: Keep this transformation function simple and deterministic based on the version, file name, and scope object. The transform function is subsequently called during URL generation, and the transformation is scanned for the output file format. As such, if you conditionally format the image as a png or jpg depending on the time of day, you will be displeased with the result of Waffle's URL generation.System Resources: If you are accepting arbitrary uploads on a public site, it may be prudent to add system resource limits to prevent overloading your system resources from malicious or nefarious files. Since all processing is done directly in ImageMagick, you may pass in system resource restrictions through the -limit flag. One such example might be: -limit area 10MB -limit disk 100MB.FFmpeg transformationsCommon transformations of uploaded videos can be also defined through your definition module:# To take a thumbnail from a video: {:ffmpeg, fn(input, output) -&gt; &quot;-i \#{input} -f jpg \#{output}&quot; end, :jpg} # To convert a video to an animated gif {:ffmpeg, fn(input, output) -&gt; &quot;-i \#{input} -f gif \#{output}&quot; end, :gif}Complex TransformationsWaffle requires the output of your transformation to be located at a predetermined path. However, the transformation may be done completely outside of Waffle. For fine-grained transformations, you should create an executable wrapper in your $PATH (eg. bash script) which takes these proper arguments, runs your transformation, and then moves the file into the correct location.For example, to use soffice to convert a doc to an html file, you should place the following bash script in your $PATH:#!/usr/bin/env sh # `soffice` doesn&#39;t allow for output file path option, and waffle can&#39;t find the # temporary file to process and copy. This script has a similar argument list as # what waffle expects. See https://github.com/stavro/arc/issues/77. set -e set -o pipefail function convert { soffice \\ --headless \\ --convert-to html \\ --outdir $TMPDIR \\ &quot;$1&quot; } function filter_new_file_name { awk -F$TMPDIR &#39;{print $2}&#39; \\ | awk -F&quot; &quot; &#39;{print $1}&#39; \\ | awk -F/ &#39;{print $2}&#39; } converted_file_name=$(convert &quot;$1&quot; | filter_new_file_name) cp $TMPDIR/$converted_file_name &quot;$2&quot; rm $TMPDIR/$converted_file_nameAnd perform the transformation as such:def transform(:html, _) do {:soffice_wrapper, fn(input, output) -&gt; [input, output] end, :html} end","ref":"Waffle.Processor.html","title":"Waffle.Processor","type":"module"},{"doc":"","ref":"Waffle.Processor.html#process/3","title":"Waffle.Processor.process/3","type":"function"},{"doc":"Local storage provides facility to store files locally.Local configurationconfig :waffle, storage: Waffle.Storage.Local, # in order to have a different storage directory from url storage_dir_prefix: &quot;priv/waffle/private&quot;, # add custom host to url asset_host: &quot;https://example.com&quot;If you want to handle your attachements by phoenix application, configure the endpoint to serve it.defmodule AppWeb.Endpoint do plug Plug.Static, at: &quot;/uploads&quot;, from: Path.expand(&quot;./priv/waffle/public/uploads&quot;), gzip: false end","ref":"Waffle.Storage.Local.html","title":"Waffle.Storage.Local","type":"module"},{"doc":"","ref":"Waffle.Storage.Local.html#delete/3","title":"Waffle.Storage.Local.delete/3","type":"function"},{"doc":"","ref":"Waffle.Storage.Local.html#put/3","title":"Waffle.Storage.Local.put/3","type":"function"},{"doc":"","ref":"Waffle.Storage.Local.html#url/4","title":"Waffle.Storage.Local.url/4","type":"function"},{"doc":"The module to facilitate integratin with S3 through ExAws.S3config :waffle, storage: Waffle.Storage.S3, bucket: {:system, &quot;AWS_S3_BUCKET&quot;}Along with any configuration necessary for ExAws.ExAws is used to support Amazon S3.To store your attachments in Amazon S3, you'll need to provide a bucket destination in your application config:config :waffle, bucket: &quot;uploads&quot;You may also set the bucket from an environment variable:config :waffle, bucket: {:system, &quot;S3_BUCKET&quot;}In addition, ExAws must be configured with the appropriate Amazon S3 credentials.ExAws has by default the following configuration (which you may override if you wish):config :ex_aws, json_codec: Jason, access_key_id: [{:system, &quot;AWS_ACCESS_KEY_ID&quot;}, :instance_role], secret_access_key: [{:system, &quot;AWS_SECRET_ACCESS_KEY&quot;}, :instance_role]This means it will first look for the AWS standard AWS_ACCESS_KEY_ID and AWS_SECRET_ACCESS_KEY environment variables, and fall back using instance meta-data if those don't exist. You should set those environment variables to your credentials, or configure an instance that this library runs on to have an iam role.Specify multiple bucketsWaffle lets you specify a bucket on a per definition basis. In case you want to use multiple buckets, you can specify a bucket in the uploader definition file like this:def bucket, do: :some_custom_bucket_nameAccess Control PermissionsWaffle defaults all uploads to private. In cases where it is desired to have your uploads public, you may set the ACL at the module level (which applies to all versions):@acl :public_readOr you may have more granular control over each version. As an example, you may wish to explicitly only make public a thumbnail version of the file:def acl(:thumb, _), do: :public_readSupported access control lists for Amazon S3 are:ACLPermissions Added to ACL:private. No one else has access rights (default).FULL_CONTROLOwner gets :public_read group gets READ access.AllUsers. The FULL_CONTROLOwner gets :public_read_write access.WRITE and READ group gets AllUsers. The FULL_CONTROLOwner gets Granting this on a bucket is generally not recommended.:authenticated_read access.READ group gets AuthenticatedUsers. The FULL_CONTROLOwner gets :bucket_owner_read access.READ. Bucket owner gets FULL_CONTROLObject owner gets :bucket_owner_full_control over the object.FULL_CONTROLBoth the object owner and the bucket owner get For more information on the behavior of each of these, please consult Amazon's documentation for Access Control List (ACL) Overview.S3 Object HeadersThe definition module may specify custom headers to pass through to S3 during object creation. The available custom headers include::cache_control:content_disposition:content_encoding:content_length:content_type:expect:expires:storage_class:website_redirect_location:encryption (set to &quot;AES256&quot; for encryption at rest)As an example, to explicitly specify the content-type of an object, you may define a s3_object_headers/2 function in your definition, which returns a Keyword list, or Map of desired headers.def s3_object_headers(version, {file, scope}) do [content_type: MIME.from_path(file.file_name)] # for &quot;image.png&quot;, would produce: &quot;image/png&quot; endAlternate S3 configuration exampleIf you are using a region other than US-Standard, it is necessary to specify the correct configuration for ex_aws. A full example configuration for both waffle and ex_aws is as follows:config :waffle, bucket: &quot;my-frankfurt-bucket&quot; config :ex_aws, json_codec: Jason, access_key_id: &quot;my_access_key_id&quot;, secret_access_key: &quot;my_secret_access_key&quot;, region: &quot;eu-central-1&quot;, s3: [ scheme: &quot;https://&quot;, host: &quot;s3.eu-central-1.amazonaws.com&quot;, region: &quot;eu-central-1&quot; ]For your host configuration, please examine the approved AWS Hostnames. There are often multiple hostname formats for AWS regions, and it will not work unless you specify the correct one.","ref":"Waffle.Storage.S3.html","title":"Waffle.Storage.S3","type":"module"},{"doc":"","ref":"Waffle.Storage.S3.html#delete/3","title":"Waffle.Storage.S3.delete/3","type":"function"},{"doc":"","ref":"Waffle.Storage.S3.html#put/3","title":"Waffle.Storage.S3.put/3","type":"function"},{"doc":"","ref":"Waffle.Storage.S3.html#url/4","title":"Waffle.Storage.S3.url/4","type":"function"},{"doc":"","ref":"Waffle.MissingExecutableError.html","title":"Waffle.MissingExecutableError","type":"exception"},{"doc":"Full Exampledefmodule Avatar do use Waffle.Definition @versions [:original, :thumb] @extension_whitelist ~w(.jpg .jpeg .gif .png) def acl(:thumb, _), do: :public_read def validate({file, _}) do file_extension = file.file_name |&gt; Path.extname |&gt; String.downcase Enum.member?(@extension_whitelist, file_extension) end def transform(:thumb, _) do {:convert, &quot;-thumbnail 100x100^ -gravity center -extent 100x100 -format png&quot;, :png} end def filename(version, _) do version end def storage_dir(_, {file, user}) do &quot;uploads/avatars/\#{user.id}&quot; end def default_url(:thumb) do &quot;https://placehold.it/100x100&quot; end end # Given some current_user record current_user = %{id: 1} # Store any accessible file Avatar.store({&quot;/path/to/my/selfie.png&quot;, current_user}) #=&gt; {:ok, &quot;selfie.png&quot;} # ..or store directly from the `params` of a file upload within your controller Avatar.store({%Plug.Upload{}, current_user}) #=&gt; {:ok, &quot;selfie.png&quot;} # and retrieve the url later Avatar.url({&quot;selfie.png&quot;, current_user}, :thumb) #=&gt; &quot;https://s3.amazonaws.com/bucket/uploads/avatars/1/thumb.png&quot;","ref":"full.html","title":"Full Example","type":"extras"}]